git-lfs/t/t-install.sh

383 lines
11 KiB
Bash
Raw Normal View History

2015-07-30 02:37:31 +00:00
#!/usr/bin/env bash
2015-06-28 12:48:59 +00:00
. "$(dirname "$0")/testlib.sh"
2015-06-28 12:48:59 +00:00
2015-11-16 20:31:26 +00:00
begin_test "install again"
2015-06-28 12:48:59 +00:00
(
set -eo pipefail
2015-06-28 12:48:59 +00:00
smudge="$(git config filter.lfs.smudge)"
clean="$(git config filter.lfs.clean)"
filter="$(git config filter.lfs.process)"
[ "$smudge" = "git-lfs smudge -- %f" ]
[ "$clean" = "git-lfs clean -- %f" ]
[ "$filter" = "git-lfs filter-process" ]
2015-06-28 12:48:59 +00:00
GIT_TRACE=1 git lfs install --skip-repo 2>&1 | tee install.log
if grep -q "--replace-all" install.log; then
echo >&2 "fatal: unexpected git config --replace-all via 'git lfs install'"
exit 1
fi
2015-06-28 12:48:59 +00:00
[ "$smudge" = "$(git config filter.lfs.smudge)" ]
[ "$clean" = "$(git config filter.lfs.clean)" ]
[ "$filter" = "$(git config filter.lfs.process)" ]
2015-06-28 12:48:59 +00:00
)
end_test
begin_test "install with old (non-upgradeable) settings"
2015-06-28 12:48:59 +00:00
(
set -e
git config --global filter.lfs.smudge "git-lfs smudge --something %f"
git config --global filter.lfs.clean "git-lfs clean --something %f"
2015-06-28 12:48:59 +00:00
2017-10-17 16:41:51 +00:00
git lfs install | tee install.log
[ "${PIPESTATUS[0]}" = 2 ]
2015-06-28 12:48:59 +00:00
2017-10-17 16:41:51 +00:00
grep -E "(clean|smudge)\" attribute should be" install.log
2015-11-16 20:31:26 +00:00
[ `grep -c "(MISSING)" install.log` = "0" ]
2015-06-28 12:48:59 +00:00
[ "git-lfs smudge --something %f" = "$(git config --global filter.lfs.smudge)" ]
[ "git-lfs clean --something %f" = "$(git config --global filter.lfs.clean)" ]
2015-07-06 23:12:31 +00:00
2015-11-16 20:31:26 +00:00
git lfs install --force
[ "git-lfs smudge -- %f" = "$(git config --global filter.lfs.smudge)" ]
[ "git-lfs clean -- %f" = "$(git config --global filter.lfs.clean)" ]
2015-06-28 12:48:59 +00:00
)
end_test
begin_test "install with upgradeable settings"
(
set -e
git config --global filter.lfs.smudge "git-lfs smudge %f"
git config --global filter.lfs.clean "git-lfs clean %f"
# should not need force, should upgrade this old style
git lfs install
[ "git-lfs smudge -- %f" = "$(git config --global filter.lfs.smudge)" ]
[ "git-lfs clean -- %f" = "$(git config --global filter.lfs.clean)" ]
[ "git-lfs filter-process" = "$(git config --global filter.lfs.process)" ]
)
end_test
2015-11-16 20:31:26 +00:00
begin_test "install updates repo hooks"
(
set -e
2015-11-16 20:31:26 +00:00
mkdir install-repo-hooks
cd install-repo-hooks
git init
pre_push_hook="#!/bin/sh
command -v git-lfs >/dev/null 2>&1 || { echo >&2 \"\\nThis repository is configured for Git LFS but 'git-lfs' was not found on your path. If you no longer wish to use Git LFS, remove this hook by deleting the 'pre-push' file in the hooks directory (set by 'core.hookspath'; usually '.git/hooks').\\n\"; exit 2; }
git lfs pre-push \"\$@\""
post_checkout_hook="#!/bin/sh
command -v git-lfs >/dev/null 2>&1 || { echo >&2 \"\\nThis repository is configured for Git LFS but 'git-lfs' was not found on your path. If you no longer wish to use Git LFS, remove this hook by deleting the 'post-checkout' file in the hooks directory (set by 'core.hookspath'; usually '.git/hooks').\\n\"; exit 2; }
git lfs post-checkout \"\$@\""
post_commit_hook="#!/bin/sh
command -v git-lfs >/dev/null 2>&1 || { echo >&2 \"\\nThis repository is configured for Git LFS but 'git-lfs' was not found on your path. If you no longer wish to use Git LFS, remove this hook by deleting the 'post-commit' file in the hooks directory (set by 'core.hookspath'; usually '.git/hooks').\\n\"; exit 2; }
git lfs post-commit \"\$@\""
post_merge_hook="#!/bin/sh
command -v git-lfs >/dev/null 2>&1 || { echo >&2 \"\\nThis repository is configured for Git LFS but 'git-lfs' was not found on your path. If you no longer wish to use Git LFS, remove this hook by deleting the 'post-merge' file in the hooks directory (set by 'core.hookspath'; usually '.git/hooks').\\n\"; exit 2; }
git lfs post-merge \"\$@\""
[ "Updated Git hooks.
2015-11-16 20:31:26 +00:00
Git LFS initialized." = "$(git lfs install)" ]
[ "$pre_push_hook" = "$(cat .git/hooks/pre-push)" ]
[ "$post_checkout_hook" = "$(cat .git/hooks/post-checkout)" ]
[ "$post_commit_hook" = "$(cat .git/hooks/post-commit)" ]
[ "$post_merge_hook" = "$(cat .git/hooks/post-merge)" ]
# replace old hook
# more-comprehensive hook update tests are in test-update.sh
echo "#!/bin/sh
git lfs push --stdin \$*" > .git/hooks/pre-push
[ "Updated Git hooks.
2015-11-16 20:31:26 +00:00
Git LFS initialized." = "$(git lfs install)" ]
[ "$pre_push_hook" = "$(cat .git/hooks/pre-push)" ]
# don't replace unexpected hook
expected="Hook already exists: pre-push
test
To resolve this, either:
1: run \`git lfs update --manual\` for instructions on how to merge hooks.
2: run \`git lfs update --force\` to overwrite your hook."
echo "test" > .git/hooks/pre-push
echo "test" > .git/hooks/post-checkout
echo "test" > .git/hooks/post-commit
echo "test" > .git/hooks/post-merge
[ "test" = "$(cat .git/hooks/pre-push)" ]
2015-11-16 20:31:26 +00:00
[ "$expected" = "$(git lfs install 2>&1)" ]
[ "test" = "$(cat .git/hooks/pre-push)" ]
[ "test" = "$(cat .git/hooks/post-checkout)" ]
[ "test" = "$(cat .git/hooks/post-commit)" ]
[ "test" = "$(cat .git/hooks/post-merge)" ]
2016-04-25 09:56:38 +00:00
# Make sure returns non-zero
set +e
git lfs install
if [ $? -eq 0 ]
then
exit 1
fi
set -e
# force replace unexpected hook
[ "Updated Git hooks.
2015-11-16 20:31:26 +00:00
Git LFS initialized." = "$(git lfs install --force)" ]
[ "$pre_push_hook" = "$(cat .git/hooks/pre-push)" ]
[ "$post_checkout_hook" = "$(cat .git/hooks/post-checkout)" ]
[ "$post_commit_hook" = "$(cat .git/hooks/post-commit)" ]
[ "$post_merge_hook" = "$(cat .git/hooks/post-merge)" ]
2015-09-17 22:35:04 +00:00
has_test_dir || exit 0
2015-09-30 23:38:13 +00:00
2015-09-17 22:35:04 +00:00
echo "test with bare repository"
cd ..
2015-11-16 20:31:26 +00:00
git clone --mirror install-repo-hooks bare-install-repo-hooks
cd bare-install-repo-hooks
2015-09-17 22:37:25 +00:00
git lfs env
2015-11-16 20:31:26 +00:00
git lfs install
2015-09-17 22:37:25 +00:00
ls -al hooks
2015-09-17 22:35:04 +00:00
[ "$pre_push_hook" = "$(cat hooks/pre-push)" ]
)
end_test
2015-09-23 17:58:16 +00:00
2015-11-16 20:31:26 +00:00
begin_test "install outside repository directory"
2015-10-19 20:47:18 +00:00
(
set -e
if [ -d "hooks" ]; then
ls -al
echo "hooks dir exists"
exit 1
fi
git lfs install > check.log 2>&1
2015-10-19 20:47:18 +00:00
if [ -d "hooks" ]; then
ls -al
echo "hooks dir exists"
exit 1
fi
cat check.log
2015-11-16 20:31:26 +00:00
# doesn't print this because being in a git repo is not necessary for install
[ "$(grep -c "Not in a Git repository" check.log)" = "0" ]
[ "$(grep -c "Error" check.log)" = "0" ]
2015-10-19 20:47:18 +00:00
)
end_test
2015-11-16 20:31:26 +00:00
begin_test "install --skip-smudge"
2015-09-23 18:20:30 +00:00
(
set -e
2016-11-30 20:43:46 +00:00
mkdir install-skip-smudge-test
cd install-skip-smudge-test
2015-11-16 20:31:26 +00:00
git lfs install
[ "git-lfs clean -- %f" = "$(git config --global filter.lfs.clean)" ]
[ "git-lfs smudge -- %f" = "$(git config --global filter.lfs.smudge)" ]
[ "git-lfs filter-process" = "$(git config --global filter.lfs.process)" ]
2015-09-23 18:20:30 +00:00
2015-11-16 20:31:26 +00:00
git lfs install --skip-smudge
[ "git-lfs clean -- %f" = "$(git config --global filter.lfs.clean)" ]
[ "git-lfs smudge --skip -- %f" = "$(git config --global filter.lfs.smudge)" ]
[ "git-lfs filter-process --skip" = "$(git config --global filter.lfs.process)" ]
2015-09-23 18:20:30 +00:00
git lfs install
[ "git-lfs clean -- %f" = "$(git config --global filter.lfs.clean)" ]
[ "git-lfs smudge -- %f" = "$(git config --global filter.lfs.smudge)" ]
[ "git-lfs filter-process" = "$(git config --global filter.lfs.process)" ]
2016-11-30 20:43:46 +00:00
[ ! -e "lfs" ]
2015-09-23 18:20:30 +00:00
)
end_test
2015-11-16 20:31:26 +00:00
begin_test "install --local"
2015-09-23 17:58:16 +00:00
(
set -e
2015-11-16 20:31:26 +00:00
# old values that should be ignored by `install --local`
git config --global filter.lfs.smudge "global smudge"
git config --global filter.lfs.clean "global clean"
git config --global filter.lfs.process "global filter"
2015-09-23 17:58:16 +00:00
2015-11-16 20:31:26 +00:00
mkdir install-local-repo
cd install-local-repo
2015-09-23 17:58:16 +00:00
git init
2015-11-16 20:31:26 +00:00
git lfs install --local
2015-09-23 17:58:16 +00:00
# local configs are correct
[ "git-lfs smudge -- %f" = "$(git config filter.lfs.smudge)" ]
[ "git-lfs smudge -- %f" = "$(git config --local filter.lfs.smudge)" ]
[ "git-lfs clean -- %f" = "$(git config filter.lfs.clean)" ]
[ "git-lfs clean -- %f" = "$(git config --local filter.lfs.clean)" ]
[ "git-lfs filter-process" = "$(git config filter.lfs.process)" ]
[ "git-lfs filter-process" = "$(git config --local filter.lfs.process)" ]
# global configs
[ "global smudge" = "$(git config --global filter.lfs.smudge)" ]
[ "global clean" = "$(git config --global filter.lfs.clean)" ]
[ "global filter" = "$(git config --global filter.lfs.process)" ]
2015-09-23 17:58:16 +00:00
)
end_test
begin_test "install --file"
(
set -e
# old values that should be ignored by `install --local`
git config --global filter.lfs.smudge "global smudge"
git config --global filter.lfs.clean "global clean"
git config --global filter.lfs.process "global filter"
mkdir install-file-repo
cd install-file-repo
git init
git lfs install --file=test-file
# local configs are correct
[ "git-lfs smudge -- %f" = "$(git config --file test-file filter.lfs.smudge)" ]
[ "git-lfs clean -- %f" = "$(git config --file test-file filter.lfs.clean)" ]
[ "git-lfs filter-process" = "$(git config --file test-file filter.lfs.process)" ]
# global configs
[ "global smudge" = "$(git config --global filter.lfs.smudge)" ]
[ "global clean" = "$(git config --global filter.lfs.clean)" ]
[ "global filter" = "$(git config --global filter.lfs.process)" ]
)
end_test
begin_test "install --local with failed permissions"
(
set -e
# Windows lacks POSIX permissions.
[ "$IS_WINDOWS" -eq 1 ] && exit 0
# Root is exempt from permissions.
[ "$(id -u)" -eq 0 ] && exit 0
mkdir install-local-repo-perms
cd install-local-repo-perms
git init
# Make it impossible to write a new .git/config file so we can't write config
# options.
chmod 500 .git
res=0
git lfs install --local >out.log || res=$?
# Cleanup fails without this.
chmod 700 .git
cat out.log
grep -E "error running.*git.*config" out.log
[ "$res" -eq 2 ]
)
end_test
2015-11-16 20:31:26 +00:00
begin_test "install --local outside repository"
2015-09-23 17:58:16 +00:00
(
set -e
# If run inside the git-lfs source dir this will update its .git/config & cause issues
if [ "$GIT_LFS_TEST_DIR" == "" ]; then
2015-11-16 20:31:26 +00:00
echo "Skipping install --local because GIT_LFS_TEST_DIR is not set"
exit 0
fi
has_test_dir || exit 0
2015-09-30 23:43:43 +00:00
set +e
git lfs install --local >out.log
2015-09-23 17:58:16 +00:00
res=$?
set -e
2015-09-23 17:58:16 +00:00
[ "Not in a Git repository." = "$(cat out.log)" ]
2015-09-23 17:58:16 +00:00
[ "0" != "$res" ]
)
end_test
2016-11-30 20:43:46 +00:00
begin_test "install --local with conflicting scope"
(
set -e
reponame="$(basename "$0" ".sh")-scope-conflict"
mkdir "$reponame"
cd "$reponame"
git init
set +e
git lfs install --local --system 2>err.log
res=$?
set -e
[ "Only one of the --local, --system, --worktree, and --file options can be specified." = "$(cat err.log)" ]
[ "0" != "$res" ]
)
end_test
2016-11-30 20:43:46 +00:00
begin_test "install in directory without access to .git/lfs"
(
set -e
mkdir not-a-repo
cd not-a-repo
mkdir .git
touch .git/lfs
touch lfs
git config --global filter.lfs.clean whatevs
[ "whatevs" = "$(git config filter.lfs.clean)" ]
git lfs install --force
[ "git-lfs clean -- %f" = "$(git config filter.lfs.clean)" ]
)
end_test
begin_test "install in repo without changing hooks"
(
set -e
git init non-lfs-repo
cd non-lfs-repo
git lfs install --skip-repo
# should not install hooks
[ ! -f .git/hooks/pre-push ]
[ ! -f .git/hooks/post-checkout ]
[ ! -f .git/hooks/post-merge ]
[ ! -f .git/hooks/post-commit ]
# filters should still be installed
[ "git-lfs clean -- %f" = "$(git config filter.lfs.clean)" ]
[ "git-lfs smudge -- %f" = "$(git config filter.lfs.smudge)" ]
[ "git-lfs filter-process" = "$(git config filter.lfs.process)" ]
)
end_test
2017-10-10 04:33:23 +00:00
begin_test "can install when multiple global values registered"
(
set -e
git config --global filter.lfs.smudge "git-lfs smudge --something %f"
git config --global --add filter.lfs.smudge "git-lfs smudge --something-else %f"
git lfs install --force
)
end_test